# Messwerte auslesen Sirius-Sensor Typ SEN55  Werner Becker 22-06-2024  Version 1.0
import network 
import urequests
import ubinascii
from ssd1306 import SSD1306_I2C
import time, utime
from machine import I2C, Pin, UART
import neopixel
import sdcard
import uos
import requests
modus = 0
server_upload = 0
data_save = 0
# Definiere die I2C-Adresse des SEN55-Sensors
SEN55_I2C_ADDRESS = 0x69  # I2C-Adresse


screen = 0

part_2_5 = 0
part_10 = 0
# Initialisiere I2C (I2C0 auf den Pins GP0 und GP1)
#i2c = I2C(1, scl=Pin(11), sda=Pin(10), freq=100000)


luft = neopixel.NeoPixel(Pin(21), 1)

i2coled=I2C(1,sda=Pin(6), scl=Pin(7), freq=400000)
oled = SSD1306_I2C(128, 64, i2coled)

i2c = I2C(0, scl=Pin(13), sda=Pin(12), freq=10000)


#Konfiguriert den UART-Port für das GPS-Modul und erstellt ein UART-Objekt.
gps_module = UART(0, baudrate=9600, tx=Pin(16), rx=Pin(17))


file_name = "/sd/InSINDEL.txt"

#Gibt Informationen über das GPS-Modul aus.
print(gps_module)

#Initialisiert Variablen für den GPS-Datenpuffer, den Timeout-Status, den Fix-Status sowie für Latitude, Longitude, Satellitenanzahl und GPS-Zeit.
buff = bytearray(255)

TIMEOUT = False
FIX_STATUS = False
latitude = ""
longitude = ""
satellites = ""
gpsTime = ""

# Assign chip select (CS) pin (and start it high)
cs = machine.Pin(1, machine.Pin.OUT)

# Initialize SPI peripheral (start with 1 MHz)
spi = machine.SPI(0,
                  baudrate=1000000,
                  polarity=0,
                  phase=0,
                  bits=8,
                  firstbit=machine.SPI.MSB,
                  sck=machine.Pin(2),
                  mosi=machine.Pin(3),
                  miso=machine.Pin(0))


# Wi-Fi credentials, replace the question mark with your corresponding WLAN connection parameters
ssid = 'iPhone von Benedikt'
password = 'UI2024!!'

# Connect to network
wlan = network.WLAN(network.STA_IF)
wlan.active(True)
mac = ubinascii.hexlify(network.WLAN().config('mac'),':').decode()
print(mac)
wlan.connect(ssid, password)

max_wait = 10
while max_wait > 0:
    if wlan.status() < 0 or wlan.status() >= 3:
        break
    max_wait -= 1
    print('waiting for connection...')
    time.sleep(1)
    
if wlan.status() != 3:
    print('network connection failed')
    
else:
    print('connected')
    status = wlan.ifconfig()
    print( 'ip = ' + status[0] )

# Try to initialize the SD card and mount the filesystem
try:
    sd = sdcard.SDCard(spi, cs)
    vfs = uos.VfsFat(sd)
    uos.mount(vfs, "/sd")
    print("SD card mounted successfully.")
except Exception as e:
    print("Failed to mount SD card:", e)
# Funktion zum Setzen der Farbe der WS2812 LED

def set_led_color_luft(color):
    luft[0] = color
    luft.write()
#Die Funktion getPositionData liest kontinuierlich Daten vom GPS-Modul, analysiert sie und setzt die globalen Variablen entsprechend.

def getPositionData(gps_module):
    global FIX_STATUS, TIMEOUT, latitude, longitude, satellites, gpsTime
    
    #Der Timeout beträgt 3 Sekunden.
    timeout = time.time() + 3
    while True:
        buff = str(gps_module.readline())
        parts = buff.split(',')
        
        #Wenn ein gültiges GPGGA-Datenpaket empfangen wird, werden Latitude, Longitude, Satellitenanzahl und GPS-Zeit aktualisiert.F
        if parts[0] == "b'$GPGGA" and len(parts) == 15:
            if parts[1] and parts[2] and parts[3] and parts[4] and parts[5] and parts[6] and parts[7]:
                #print(buff)
                latitude = convertToDegree(parts[2])
                if parts[3] == 'S':
                    latitude = -float(latitude)
                longitude = convertToDegree(parts[4])
                if parts[5] == 'W':
                    longitude = -float(longitude)
                satellites = parts[7]
                gpsTime = parts[1][0:2] + "-" + parts[1][2:4] + "-" + parts[1][4:6]
                #Der Fix-Status wird auf True gesetzt, und die Daten werden in die CSV-Datei gespeichert.
                FIX_STATUS = True
                # Save data to CSV file every 5 seconds
                #if int(time.time()) % 5 == 0:
                    #saveToCSV(file_name, gpsTime, latitude, longitude)
                #Die Schleife wird durch break beendet.
                break
               
        #Falls der Timeout erreicht wird, wird der TIMEOUT-Status auf True gesetzt.
        if time.time() > timeout:
            TIMEOUT = True
            break
        time.sleep(0.5)
        #print("stuck")

#Die Funktion convertToDegree konvertiert rohe GPS-Koordinaten in Grad mit Dezimalstellen.
def convertToDegree(raw_degrees):
    try:
        raw_as_float = float(raw_degrees)
        degrees = int(raw_as_float / 100)
        minutes = raw_as_float - float(degrees * 100)
        converted = '{0:.6f}'.format(degrees + minutes / 60.0)
        return converted
    except ValueError:
        print(f"Error converting {raw_degrees} to float.")
        return None

#Die Funktion saveToCSV fügt eine neue Zeile mit GPS-Daten zur CSV-Datei hinzu.
#def saveToCSV(file_name, gpsTime, latitude, longitude):
 #   try:
        # Get today's date
  #      current_time = utime.localtime()
   #      
        # Datum und Uhrzeit im gewünschten Format erstellen
    #    timestamp = "{:04}-{:02}-{:02} {:02}:{:02}:{:02}".format(
     #       current_time[0], current_time[1], current_time[2],
      #      current_time[3], current_time[4], current_time[5]
       # )
        
    #    with open(file_name, 'a') as file:
         #   file.write(f"{latitude}, {longitude}\n")
    #except Exception as e:
    #    print(f"Error saving to CSV: {e}")


modus = 0
interrupt_flags1=0
interrupt_flags2=0
pins1 = Pin(4,Pin.IN,Pin.PULL_UP)
def callback(pins1):
    global interrupt_flags1
    interrupt_flags1=1
    set_led_color_luft((30, 30, 30))#blau
    time.sleep(1)

pins1.irq(trigger=Pin.IRQ_FALLING, handler=callback)

pins2 = Pin(5,Pin.IN,Pin.PULL_UP)
def callback(pins2):
    global interrupt_flags2
    interrupt_flags2=1
    set_led_color_luft((30, 30, 30))#blau
    time.sleep(1)

pins2.irq(trigger=Pin.IRQ_FALLING, handler=callback)
def sensirion_i2c_sleep(microseconds):
    time.sleep_us(microseconds)

def sensirion_i2c_read(bus, address, length):
    try:
        data = bus.readfrom(address, length)
        return list(data), 0
    except Exception as e:
        print(f"I2C read error: {e}")
        return [], -1

def sensirion_i2c_add_command_to_buffer(buffer, offset, command):
    """
    Fügt einen Befehl zum Buffer hinzu und gibt den neuen Offset zurück.
    """
    buffer[offset] = (command >> 8) & 0xFF  # Höheres Byte
    buffer[offset + 1] = command & 0xFF  # Niedrigeres Byte
    return offset + 2

def sensirion_i2c_write_data(bus, i2c_address, buffer, length):
    """
    Sendet die Daten im Buffer an die angegebene I2C-Adresse.
    """
    try:
        bus.writeto(i2c_address, bytes(buffer[:length]))
        return 0  # NO_ERROR
    except Exception as e:
        print(f"I2C write error: {e}")
        return -1  # Fehlercode

def sen5x_read_measured_values():
    NO_ERROR = 0
    DATA_LENGTH = 23  # Länge der zu lesenden Daten
    buffer = [0] * 2

    offset = sensirion_i2c_add_command_to_buffer(buffer, 0, 0x03C4)

    error = sensirion_i2c_write_data(i2c, SEN55_I2C_ADDRESS, buffer, offset)
    if error:
        return None, error

    sensirion_i2c_sleep(50000)

    data, error = sensirion_i2c_read(i2c, SEN55_I2C_ADDRESS, DATA_LENGTH)
    if error:
        return None, error

    mass_concentration_pm1p0 = (data[0] << 8) | data[1]
    mass_concentration_pm2p5 = (data[3] << 8) | data[4]
    mass_concentration_pm4p0 = (data[6] << 8) | data[7]
    mass_concentration_pm10p0 = (data[9] << 8) | data[10]
    ambient_humidity = (data[12] << 8) | data[13]
    ambient_temperature = (data[15] << 8) | data[16]
    voc_index = (data[18] << 8) | data[19]
    nox_index = (data[21] << 8) | data[22]

    measured_values = (
        mass_concentration_pm1p0, mass_concentration_pm2p5, 
        mass_concentration_pm4p0, mass_concentration_pm10p0, 
        ambient_humidity, ambient_temperature, 
        voc_index, nox_index
    )

    return measured_values, NO_ERROR

def sen5x_start_measurement():
    buffer = [0] * 2
    offset = sensirion_i2c_add_command_to_buffer(buffer, 0, 0x0021)

    error = sensirion_i2c_write_data(i2c, SEN55_I2C_ADDRESS, buffer, offset)
    return error



sen5x_start_measurement()



while True:
            sensirion_i2c_sleep(1000000)
            measured_values, error = sen5x_read_measured_values()
            if error:
                print("Fehler beim Lesen der Messwerte")
                continue
            t = round((measured_values[5] / 200.0), 1)  # Temperatur auf eine Kommastelle gerundet
            f = round((measured_values[4] / 100.0), 1)  # Feuchte auf eine Kommastelle gerundet
            
            getPositionData(gps_module)
            
            print("PM(1.0) =", str(measured_values[0]/10.0) + "μg/m³")
            print("PM(2.5) =", str(measured_values[1]/10.0) + "μg/m³")
            print("PM(4.0) =", str(measured_values[2]/10.0) + "μg/m³")
            print("PM(10) =", str(measured_values[3]/10.0) + "μg/m³")
            print("Feuchte =", str(f) + "%")
            print("Temperatur =", str(t) + "°C")
            print("VOC Index =", str(measured_values[6] / 10.0))
            print("NOX Index =", str(measured_values[7] / 10.0))
            print("---")
            
            if interrupt_flags1 is 1:
                print("Interrupts1 has occured")
                interrupt_flags1=0
                if server_upload == 1:
                    server_upload = 0
                else:
                    server_upload = 1
            if interrupt_flags2 is 1:
                print("Interrupts2 has occured")
                interrupt_flags2=0
                if data_save == 1:
                    data_save = 0
                else:
                    data_save = 1
            if screen == 0 and modus == 0:   
                oled.text("Screen1", 35, 0)
                oled.text("PM1.0=", 0, 10)
                oled.text(str(measured_values[0]/10.0), 55, 10)
                oled.text("ug/m3", 85, 10)
                oled.text("PM2.5=", 0, 20)
                oled.text(str(measured_values[1]/10.0), 55, 20)
                oled.text("ug/m3", 85, 20)
                oled.text("PM4.0=", 0, 30)
                oled.text(str(measured_values[2]/10.0), 55, 30)
                oled.text("ug/m3", 85, 30)
                oled.text("PM10=", 0, 40)
                oled.text(str(measured_values[3]/10.0), 55, 40)
                oled.text("ug/m3", 85, 40)
            if screen == 1 and modus == 0:
                oled.text("Screen2", 35, 0)
                oled.text("Feuchte:", 0, 10)
                oled.text(str(f), 65, 10)
                oled.text("%", 100, 10)
                oled.text("Temp:", 0, 20)
                oled.text(str(t), 65, 20)
                oled.text("C", 100, 20)
                oled.text("VOC:", 0, 30)
                oled.text(str(measured_values[6] / 10.0), 65, 30)
                oled.text("NOX:", 0, 40)
                oled.text(str(measured_values[7] / 10.0), 65, 40)
            if modus == 1:
                oled.text("Screen1", 35, 0)
                oled.text("PM1.0=", 0, 10)
                oled.text(str(measured_values[0]/10.0), 55, 10)
                oled.text("ug/m3", 85, 10)
                oled.text("PM2.5=", 0, 20)
                oled.text(str(measured_values[1]/10.0), 55, 20)
                oled.text("ug/m3", 85, 20)
                oled.text("PM4.0=", 0, 30)
                oled.text(str(measured_values[2]/10.0), 55, 30)
                oled.text("ug/m3", 85, 30)
                oled.text("PM10=", 0, 40)
                oled.text(str(measured_values[3]/10.0), 55, 40)
                oled.text("ug/m3", 85, 40)
            if modus == 2:
                oled.text("Screen2", 35, 0)
                oled.text("Feuchte:", 0, 10)
                oled.text(str(f), 65, 10)
                oled.text("%", 100, 10)
                oled.text("Temp:", 0, 20)
                oled.text(str(t), 65, 20)
                oled.text("C", 100, 20)
                oled.text("VOC:", 0, 30)
                oled.text(str(measured_values[6] / 10.0), 65, 30)
                oled.text("NOX:", 0, 40)
                oled.text(str(measured_values[7] / 10.0), 65, 40)
            if measured_values[1]/10.0 < 150.00 or measured_values[3]/10.0 < 150.00 or measured_values[7] / 10.0 < 150.00:
                set_led_color_luft((0, 50, 15))#rosa
                print("rosa")
            if measured_values[0]/10.0 > 150.00 or measured_values[3]/10.0 > 150.00 or measured_values[7] / 10.0 > 150.00:
                set_led_color_luft((0, 0, 30))#blau
                print("blau")
            if TIMEOUT:
                oled.text("No GPS", 0, 50)
                TIMEOUT = False
                #with open("/sd/NOGPSTRYONE.txt", 'a') as file:
                    #file.write(str(measured_values[0]/10.0) + "," + str(measured_values[1]/10.0) + "," + str(measured_values[2]/10.0) + "," + str(measured_values[3]/10.0) + "," + str(f) + "," + str(t) + "," + str(measured_values[6] / 10.0) + "," + str(measured_values[7] / 10.0)+  "\n")
                    #lat, long, pm1.0, pm2.5, pm4, pm10, feuchte, temp, VOC, NOX
            if FIX_STATUS:
                oled.text("GPS found.", 0, 50)
                FIX_STATUS = False
                if measured_values[1]/10.0 < 150.00 or measured_values[3]/10.0 < 150.00 or measured_values[7] / 10.0 < 150.00:
                    set_led_color_luft((30, 0, 0))#grün
                elif measured_values[0]/10.0 > 150.00 or measured_values[3]/10.0 > 150.00 or measured_values[7] / 10.0 > 150.00:
                    set_led_color_luft((00, 30, 00))#rot
                if data_save == 1:
                    oled.text("SAVING.", 65, 50)
                    with open(file_name, 'a') as file:
                        file.write(str(gpsTime) + "," + str(latitude) + "," + str(longitude) + "," + str(measured_values[0]/10.0) + "," + str(measured_values[1]/10.0) + "," + str(measured_values[2]/10.0) + "," + str(measured_values[3]/10.0) + "," + str(f) + "," + str(t) + "," + str(measured_values[6] / 10.0) + "," + str(measured_values[7] / 10.0)+  "\n")
                    #lat, long, pm1.0, pm2.5, pm4, pm10, feuchte, temp, VOC, NOX
                if server_upload == 1:
                    part_2_5 = measured_values[1]/10.0
                    part_10 = measured_values[3]/10.0
                    #current_time = utime.localtime()
                    #timestamp = "{:04}-{:02}-{:02} {:02}:{:02}:{:02}".format(
                    #current_time[0], current_time[1], current_time[2],
                    #current_time[3], current_time[4], current_time[5]
                    #)
                    # Aktuelle Zeit holen (in UTC)
                    current_time = utime.localtime()  # Gibt ein Tupel mit (Jahr, Monat, Tag, Stunde, Minute, Sekunde, Wochentag, Jahr_Tag)
                    # Timestamp im ISO 8601-Format erstellen
                    timestamp = "{:04}-{:02}-{:02}T{:02}:{:02}:{:02}.000+00:00".format(
                    current_time[0], current_time[1], current_time[2],  # Jahr, Monat, Tag
                    current_time[3], current_time[4], current_time[5]  ) # Stunde, Minute, Sekunde
                    try:
                        obj = {
                            "token": "505eb96f-34f3-426f-a0a6-ff9c27cee9f7", # request a token from https://www.gm4s.eu                            
                            "measured_at": f"{timestamp}",  # Timestamp mit doppelten Anführungszeichen
                            "lat": latitude,
                            "long": longitude,
                            "hum": f,
                            "temp": t,
                            "part_2_5": part_2_5,
                            "part_10": part_10
                            }
                        print(timestamp)
                        print(obj)
                        response = urequests.post("https://www.gm4s.eu/api/addMarker", json=obj)
                        # Get response code
                        response_code = response.status_code
                        # Get response content
                        response_content = response.text  # Use `.text` for string content

                        # Print results
                        print('Response code: ', response_code)
                        print('Response content:', response_content)  # Print first 100 chars
                    except Exception as e:
                        print('Failed to make request:', e)
            oled.show()
            screen = 1 - screen
            oled.fill(0)
            time.sleep(5)

