import time
import network
import urequests
import ubinascii

# Wi-Fi credentials
ssid = 'Tango_618A'
password = '39802990842287053248'

# Connect to network
wlan = network.WLAN(network.STA_IF)
wlan.active(True)
mac = ubinascii.hexlify(network.WLAN().config('mac'), ':').decode()
print(mac)
wlan.connect(ssid, password)

max_wait = 10
while max_wait > 0:
    if wlan.status() < 0 or wlan.status() >= 3:
        break
    max_wait -= 1
    print('waiting for connection...')
    time.sleep(1)

if wlan.status() != 3:
    print('network connection failed')
else:
    print('Connected')
    status = wlan.ifconfig()
    print('IP = ' + status[0])

# Function to send data to server
def send_data(data):
    try:
        response = urequests.post("https://www.gm4s.eu/api/addMarker", json=data)
        print('Response code:', response.status_code)
        print('Response content:', response.text)
        response.close()
    except Exception as e:
        print('Failed to make request:', e)

# Read file and send data
file_path = "/sd/finaltest.txt"  # Passe den Pfad zur Datei an
print(file_path)
try:
    print("46")
    with open(file_path, "r") as file:
        print("47")
        for line in file:
            print("49")
            values = line.strip().split(",")  # Annahme: CSV-Format
            if len(values) < 6:
                print("Invalid data:", line)
                continue
            
            obj = {
                "token": "505eb96f-34f3-426f-a0a6-ff9c27cee9f7",
                "measured_at": values[0],  # Beispiel: Datum/Uhrzeit
                "lat": float(values[1]),
                "long": float(values[2]),
                "co2": int(values[3]),
                "hum": int(values[4]),
                "temp": int(values[5]),
                "part_2_5": int(values[6]) if len(values) > 6 else 0,
                "part_5": int(values[7]) if len(values) > 7 else 0,
                "part_10": int(values[8]) if len(values) > 8 else 0
            }
            
            send_data(obj)
            time.sleep(1)  # Wartezeit zwischen Anfragen (vermeidet Überlastung)

except OSError as e:
    print("Error reading file:", e)
