import time
import network 
import urequests
import ubinascii


# Wi-Fi credentials, replace the question mark with your corresponding WLAN connection parameters
ssid = 'Tango_618A'
password = '39802990842287053248'

# Connect to network
wlan = network.WLAN(network.STA_IF)
wlan.active(True)
mac = ubinascii.hexlify(network.WLAN().config('mac'),':').decode()
print(mac)
wlan.connect(ssid, password)

max_wait = 10
while max_wait > 0:
    if wlan.status() < 0 or wlan.status() >= 3:
        break
    max_wait -= 1
    print('waiting for connection...')
    time.sleep(1)
    
if wlan.status() != 3:
    raise RuntimeError('network connection failed')
else:
    print('connected')
    status = wlan.ifconfig()
    print( 'ip = ' + status[0] )

# Make a GET request 
try:
    obj = {
        "token": "505eb96f-34f3-426f-a0a6-ff9c27cee9f7", # request a token from https://www.gm4s.eu
        "measured_at": "2025-03-10T14:30:00Z",
        "lat": 49.85369356630294,
        "long": 6.101258269104292,
        "co2": 9999999999,
        "hum": 87,
        "temp": -3,
        "part_2_5": 2,
        "part_5": 1,
        "part_10": 200000000
        }
    response = urequests.post("https://www.gm4s.eu/api/addMarker", json=obj)
    # Get response code
    response_code = response.status_code
    # Get response content
    response_content = response.text  # Use `.text` for string content

    # Print results
    print('Response code: ', response_code)
    print('Response content:', response_content)  # Print first 100 chars
except Exception as e:
    print('Failed to make request:', e)
    